-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Speech To Text
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Charts - Sparklines
In this demo, a set of line-like sparklines is placed into a table. Although these sparklines look similar, they have different series types. The first table column contains sparklines of the line series type. In the second table column, spline sparklines are placed. The third table column displays sparklines of the step line series type.
Backend API
$(() => {
const oilOptions = {
dataSource: oilCosts,
argumentField: 'month',
valueField: '2010',
type: 'line',
showMinMax: true,
tooltip: {
format: 'currency',
},
};
const goldOptions = {
dataSource: goldCosts,
argumentField: 'month',
valueField: '2010',
type: 'spline',
lineWidth: 3,
lineColor: '#9ab57e',
minColor: '#6babac',
maxColor: '#ebdd8f',
showMinMax: true,
showFirstLast: false,
tooltip: {
format: 'currency',
},
};
const silverOptions = {
dataSource: silverCosts,
argumentField: 'month',
valueField: '2010',
lineColor: '#e8c267',
firstLastColor: '#e55253',
pointSize: 6,
pointSymbol: 'square',
pointColor: '#ebdd8f',
type: 'stepline',
tooltip: {
format: 'currency',
},
};
$('.line2010').dxSparkline(oilOptions);
$('.spline2010').dxSparkline(goldOptions);
$('.stepline2010').dxSparkline(silverOptions);
$('.line2011').dxSparkline($.extend(oilOptions, { valueField: '2011' }));
$('.spline2011').dxSparkline($.extend(goldOptions, { valueField: '2011' }));
$('.stepline2011').dxSparkline($.extend(silverOptions, { valueField: '2011' }));
$('.line2012').dxSparkline($.extend(oilOptions, { valueField: '2012' }));
$('.spline2012').dxSparkline($.extend(goldOptions, { valueField: '2012' }));
$('.stepline2012').dxSparkline($.extend(silverOptions, { valueField: '2012' }));
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.7/css/dx.light.css" />
<script src="js/dx.all.js?v=25.1.7"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="long-title"><h3>Monthly Prices of Oil, Gold and Silver</h3></div>
<div id="chart-demo">
<table class="demo-table">
<tr>
<th></th>
<th>Oil (USD/barrel)</th>
<th>Gold (USD/troy ounce)</th>
<th>Silver (USD/troy ounce)</th>
</tr>
<tr>
<th>2010</th>
<td><div class="sparkline line2010"></div></td>
<td><div class="sparkline spline2010"></div></td>
<td><div class="sparkline stepline2010"></div></td>
</tr>
<tr>
<th>2011</th>
<td><div class="sparkline line2011"></div></td>
<td><div class="sparkline spline2011"></div></td>
<td><div class="sparkline stepline2011"></div></td>
</tr>
<tr>
<th>2012</th>
<td><div class="sparkline line2012"></div></td>
<td><div class="sparkline spline2012"></div></td>
<td><div class="sparkline stepline2012"></div></td>
</tr>
</table>
</div>
</div>
</body>
</html>
#chart-demo {
height: 440px;
}
.demo-table {
width: 100%;
border: 1px solid #c2c2c2;
border-collapse: collapse;
}
.demo-table th,
.demo-table td {
font-weight: 400;
width: 200px;
padding: 25px 10px 5px;
border: 1px solid #c2c2c2;
}
.demo-table th {
padding: 25px 15px 20px;
border: 1px solid #c2c2c2;
}
.demo-table tr:nth-child(2) td {
border-top: 1px solid #c2c2c2;
}
.demo-table td:first-of-type {
border-left: 1px solid #c2c2c2;
}
.demo-table .sparkline {
width: 200px;
height: 30px;
}
.long-title h3 {
font-weight: 200;
font-size: 28px;
text-align: center;
margin-bottom: 20px;
margin-top: 0;
}
const oilCosts = [{
month: 1,
2010: 77,
2011: 93,
2012: 107,
}, {
month: 2,
2010: 72,
2011: 101,
2012: 112,
}, {
month: 3,
2010: 79,
2011: 115,
2012: 123,
}, {
month: 4,
2010: 82,
2011: 116,
2012: 123,
}, {
month: 5,
2010: 86,
2011: 124,
2012: 116,
}, {
month: 6,
2010: 73,
2011: 115,
2012: 102,
}, {
month: 7,
2010: 73,
2011: 110,
2012: 94,
}, {
month: 8,
2010: 77,
2011: 117,
2012: 105,
}, {
month: 9,
2010: 76,
2011: 113,
2012: 113,
}, {
month: 10,
2010: 81,
2011: 103,
2012: 111,
}, {
month: 11,
2010: 83,
2011: 110,
2012: 107,
}, {
month: 12,
2010: 89,
2011: 109,
2012: 110,
}];
const goldCosts = [{
month: 1,
2010: 1115,
2011: 1358,
2012: 1661,
}, {
month: 2,
2010: 1099,
2011: 1375,
2012: 1742,
}, {
month: 3,
2010: 1114,
2011: 1423,
2012: 1677,
}, {
month: 4,
2010: 1150,
2011: 1486,
2012: 1650,
}, {
month: 5,
2010: 1205,
2011: 1511,
2012: 1589,
}, {
month: 6,
2010: 1235,
2011: 1529,
2012: 1602,
}, {
month: 7,
2010: 1193,
2011: 1573,
2012: 1593,
}, {
month: 8,
2010: 1220,
2011: 1765,
2012: 1634,
}, {
month: 9,
2010: 1272,
2011: 1771,
2012: 1750,
}, {
month: 10,
2010: 1345,
2011: 1672,
2012: 1745,
}, {
month: 11,
2010: 1370,
2011: 1741,
2012: 1720,
}, {
month: 12,
2010: 1392,
2011: 1643,
2012: 1684,
}];
const silverCosts = [{
month: 1,
2010: 17,
2011: 30,
2012: 27,
}, {
month: 2,
2010: 28,
2011: 28,
2012: 33,
}, {
month: 3,
2010: 34,
2011: 34,
2012: 35,
}, {
month: 4,
2010: 37,
2011: 37,
2012: 32,
}, {
month: 5,
2010: 47,
2011: 47,
2012: 30,
}, {
month: 6,
2010: 37,
2011: 37,
2012: 28,
}, {
month: 7,
2010: 34,
2011: 34,
2012: 27,
}, {
month: 8,
2010: 40,
2011: 40,
2012: 27,
}, {
month: 9,
2010: 41,
2011: 41,
2012: 31,
}, {
month: 10,
2010: 30,
2011: 30,
2012: 34,
}, {
month: 11,
2010: 34,
2011: 34,
2012: 31,
}, {
month: 12,
2010: 32,
2011: 32,
2012: 33,
}];

<template>
<div>
<div class="long-title"><h3>Monthly Prices of Oil, Gold and Silver</h3></div>
<div id="chart-demo">
<table class="demo-table">
<tr>
<th/>
<th>Oil (USD/barrel)</th>
<th>Gold (USD/troy ounce)</th>
<th>Silver (USD/troy ounce)</th>
</tr>
<tbody
v-for="(year, index) in years"
:key="index"
>
<RowTemplate :year="year"/>
</tbody>
</table>
</div>
</div>
</template>
<script>
import RowTemplate from './RowTemplate.vue';
export default {
components: {
RowTemplate,
},
data() {
return {
years: ['2010', '2011', '2012'],
};
},
};
</script>
<style>
#chart-demo {
height: 440px;
}
.demo-table {
width: 100%;
border: 1px solid #c2c2c2;
border-collapse: collapse;
}
.demo-table th {
font-weight: 400;
width: 200px;
padding: 25px 15px 20px 15px;
border: 1px solid #c2c2c2;
}
.long-title h3 {
font-weight: 200;
font-size: 28px;
text-align: center;
margin-bottom: 20px;
margin-top: 0;
}
</style>
<template>
<tr class="rows-content">
<th>{{ year }}</th>
<td>
<DxSparkline
:data-source="oilCosts"
:show-min-max="true"
:value-field="year"
class="sparkline"
argument-field="month"
type="line"
>
<DxTooltip format="currency"/>
</DxSparkline>
</td>
<td>
<DxSparkline
:data-source="goldCosts"
:line-width="3"
:show-min-max="true"
:show-first-last="false"
:value-field="year"
class="sparkline"
argument-field="month"
type="spline"
line-color="#9ab57e"
min-color="#6babac"
max-color="#ebdd8f"
>
<DxTooltip format="currency"/>
</DxSparkline>
</td>
<td>
<DxSparkline
:data-source="silverCosts"
:point-size="6"
:value-field="year"
class="sparkline"
argument-field="month"
type="stepline"
line-color="#e8c267"
first-last-color="#e55253"
point-symbol="square"
point-color="#ebdd8f"
>
<DxTooltip format="currency"/>
</DxSparkline>
</td>
</tr>
</template>
<script>
import DxSparkline, {
DxTooltip,
} from 'devextreme-vue/sparkline';
import {
oilCosts,
goldCosts,
silverCosts,
} from './data.js';
export default {
components: {
DxSparkline,
DxTooltip,
},
props: {
year: {
type: String,
default() {},
},
},
data() {
return {
oilCosts,
goldCosts,
silverCosts,
};
},
};
</script>
<style>
.rows-content td {
font-weight: 400;
width: 200px;
padding: 25px 10px 5px 10px;
border: 1px solid #c2c2c2;
}
.rows-content tr:nth-child(2) td {
border-top: 1px solid #c2c2c2;
}
.rows-content td:first-of-type {
border-left: 1px solid #c2c2c2;
}
.rows-content .sparkline {
width: 200px;
height: 30px;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/21.2.7/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/21.2.7/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
export const oilCosts = [{
month: 1,
2010: 77,
2011: 93,
2012: 107,
}, {
month: 2,
2010: 72,
2011: 101,
2012: 112,
}, {
month: 3,
2010: 79,
2011: 115,
2012: 123,
}, {
month: 4,
2010: 82,
2011: 116,
2012: 123,
}, {
month: 5,
2010: 86,
2011: 124,
2012: 116,
}, {
month: 6,
2010: 73,
2011: 115,
2012: 102,
}, {
month: 7,
2010: 73,
2011: 110,
2012: 94,
}, {
month: 8,
2010: 77,
2011: 117,
2012: 105,
}, {
month: 9,
2010: 76,
2011: 113,
2012: 113,
}, {
month: 10,
2010: 81,
2011: 103,
2012: 111,
}, {
month: 11,
2010: 83,
2011: 110,
2012: 107,
}, {
month: 12,
2010: 89,
2011: 109,
2012: 110,
}];
export const goldCosts = [{
month: 1,
2010: 1115,
2011: 1358,
2012: 1661,
}, {
month: 2,
2010: 1099,
2011: 1375,
2012: 1742,
}, {
month: 3,
2010: 1114,
2011: 1423,
2012: 1677,
}, {
month: 4,
2010: 1150,
2011: 1486,
2012: 1650,
}, {
month: 5,
2010: 1205,
2011: 1511,
2012: 1589,
}, {
month: 6,
2010: 1235,
2011: 1529,
2012: 1602,
}, {
month: 7,
2010: 1193,
2011: 1573,
2012: 1593,
}, {
month: 8,
2010: 1220,
2011: 1765,
2012: 1634,
}, {
month: 9,
2010: 1272,
2011: 1771,
2012: 1750,
}, {
month: 10,
2010: 1345,
2011: 1672,
2012: 1745,
}, {
month: 11,
2010: 1370,
2011: 1741,
2012: 1720,
}, {
month: 12,
2010: 1392,
2011: 1643,
2012: 1684,
}];
export const silverCosts = [{
month: 1,
2010: 17,
2011: 30,
2012: 27,
}, {
month: 2,
2010: 28,
2011: 28,
2012: 33,
}, {
month: 3,
2010: 34,
2011: 34,
2012: 35,
}, {
month: 4,
2010: 37,
2011: 37,
2012: 32,
}, {
month: 5,
2010: 47,
2011: 47,
2012: 30,
}, {
month: 6,
2010: 37,
2011: 37,
2012: 28,
}, {
month: 7,
2010: 34,
2011: 34,
2012: 27,
}, {
month: 8,
2010: 40,
2011: 40,
2012: 27,
}, {
month: 9,
2010: 41,
2011: 41,
2012: 31,
}, {
month: 10,
2010: 30,
2011: 30,
2012: 34,
}, {
month: 11,
2010: 34,
2011: 34,
2012: 31,
}, {
month: 12,
2010: 32,
2011: 32,
2012: 33,
}];
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'vue': 'npm:vue@3.0.0/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@21.2.7/cjs',
'devextreme-vue': 'npm:devextreme-vue@21.2.7',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.14/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.47/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.0.13/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@2.3.14',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@2.3.14/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);

<div class="long-title"><h3>Monthly Prices of Oil, Gold and Silver</h3></div>
<div id="chart-demo">
<table class="demo-table">
<tr>
<th></th>
<th>Oil (USD/barrel)</th>
<th>Gold (USD/troy ounce)</th>
<th>Silver (USD/troy ounce)</th>
</tr>
<tr *ngFor="let year of years">
<th>{{year}}</th>
<td>
<dx-sparkline class="sparkline"
[dataSource]="oilCosts"
argumentField="month"
valueField="{{year}}"
type="line"
[showMinMax]="true">
<dxo-tooltip format="currency"></dxo-tooltip>
</dx-sparkline>
</td>
<td>
<dx-sparkline class="sparkline"
[dataSource]="goldCosts"
argumentField="month"
valueField="{{year}}"
type="spline"
[lineWidth]="3"
lineColor="#9ab57e"
minColor="#6babac"
maxColor="#ebdd8f"
[showMinMax]="true"
[showFirstLast]="false">
<dxo-tooltip format="currency"></dxo-tooltip>
</dx-sparkline>
</td>
<td>
<dx-sparkline class="sparkline"
[dataSource]="silverCosts"
argumentField="month"
valueField="{{year}}"
type="stepline"
lineColor="#e8c267"
firstLastColor="#e55253"
[pointSize]="6"
pointSymbol="square"
pointColor="#ebdd8f">
<dxo-tooltip format="currency"></dxo-tooltip>
</dx-sparkline>
</td>
</tr>
</table>
</div>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxSparklineModule } from 'devextreme-angular';
import { CostInfo, Service } from './app.service';
if(!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
providers: [Service]
})
export class AppComponent {
oilCosts: CostInfo[];
goldCosts: CostInfo[];
silverCosts: CostInfo[];
years: Array<number>;
constructor(service: Service) {
this.oilCosts = service.getOilCosts();
this.goldCosts = service.getGoldCosts();
this.silverCosts = service.getSilverCosts();
this.years = [2010, 2011, 2012];
}
}
@NgModule({
imports: [
BrowserModule,
DxSparklineModule
],
declarations: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #chart-demo {
height: 440px;
}
::ng-deep .demo-table {
width: 100%;
border: 1px solid #c2c2c2;
border-collapse: collapse;
}
::ng-deep .demo-table th,
::ng-deep .demo-table td {
font-weight: 400;
width: 200px;
padding: 25px 10px 5px 10px;
border: 1px solid #c2c2c2;
}
::ng-deep .demo-table th {
padding: 25px 15px 20px 15px;
border: 1px solid #c2c2c2;
}
::ng-deep .demo-table tr:nth-child(2) td {
border-top: 1px solid #c2c2c2;
}
::ng-deep .demo-table td:first-of-type {
border-left: 1px solid #c2c2c2;
}
::ng-deep .demo-table .sparkline {
width: 200px;
height: 30px;
}
::ng-deep .long-title h3 {
font-weight: 200;
font-size: 28px;
text-align: center;
margin-bottom: 20px;
}
import { Injectable } from '@angular/core';
export class CostInfo {
month: number;
2010: number;
2011: number;
2012: number;
}
let oilCosts: CostInfo[] = [{
month: 1,
2010: 77,
2011: 93,
2012: 107
}, {
month: 2,
2010: 72,
2011: 101,
2012: 112
}, {
month: 3,
2010: 79,
2011: 115,
2012: 123
}, {
month: 4,
2010: 82,
2011: 116,
2012: 123
}, {
month: 5,
2010: 86,
2011: 124,
2012: 116
}, {
month: 6,
2010: 73,
2011: 115,
2012: 102
}, {
month: 7,
2010: 73,
2011: 110,
2012: 94
}, {
month: 8,
2010: 77,
2011: 117,
2012: 105
}, {
month: 9,
2010: 76,
2011: 113,
2012: 113
}, {
month: 10,
2010: 81,
2011: 103,
2012: 111
}, {
month: 11,
2010: 83,
2011: 110,
2012: 107
}, {
month: 12,
2010: 89,
2011: 109,
2012: 110
}];
let goldCosts: CostInfo[] = [{
month: 1,
2010: 1115,
2011: 1358,
2012: 1661
}, {
month: 2,
2010: 1099,
2011: 1375,
2012: 1742
}, {
month: 3,
2010: 1114,
2011: 1423,
2012: 1677
}, {
month: 4,
2010: 1150,
2011: 1486,
2012: 1650
}, {
month: 5,
2010: 1205,
2011: 1511,
2012: 1589
}, {
month: 6,
2010: 1235,
2011: 1529,
2012: 1602
}, {
month: 7,
2010: 1193,
2011: 1573,
2012: 1593
}, {
month: 8,
2010: 1220,
2011: 1765,
2012: 1634
}, {
month: 9,
2010: 1272,
2011: 1771,
2012: 1750
}, {
month: 10,
2010: 1345,
2011: 1672,
2012: 1745
}, {
month: 11,
2010: 1370,
2011: 1741,
2012: 1720
}, {
month: 12,
2010: 1392,
2011: 1643,
2012: 1684
}];
let silverCosts: CostInfo[] = [{
month: 1,
2010: 17,
2011: 30,
2012: 27
}, {
month: 2,
2010: 28,
2011: 28,
2012: 33
}, {
month: 3,
2010: 34,
2011: 34,
2012: 35
}, {
month: 4,
2010: 37,
2011: 37,
2012: 32
}, {
month: 5,
2010: 47,
2011: 47,
2012: 30
}, {
month: 6,
2010: 37,
2011: 37,
2012: 28
}, {
month: 7,
2010: 34,
2011: 34,
2012: 27
}, {
month: 8,
2010: 40,
2011: 40,
2012: 27
}, {
month: 9,
2010: 41,
2011: 41,
2012: 31
}, {
month: 10,
2010: 30,
2011: 30,
2012: 34
}, {
month: 11,
2010: 34,
2011: 34,
2012: 31
}, {
month: 12,
2010: 32,
2011: 32,
2012: 33
}];
@Injectable()
export class Service {
getOilCosts(): CostInfo[] {
return oilCosts;
}
getGoldCosts(): CostInfo[] {
return goldCosts;
}
getSilverCosts(): CostInfo[] {
return silverCosts;
}
}
// In real applications, you should not transpile code in the browser. You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
System.config({
transpiler: 'ts',
typescriptOptions: {
module: "system",
emitDecoratorMetadata: true,
experimentalDecorators: true
},
meta: {
'typescript': {
"exports": "ts"
},
'devextreme/localization.js': {
"esModule": true
}
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@3.5.3/lib/typescript.js',
'@angular': 'npm:@angular',
'tslib': 'npm:tslib@2.1.0/tslib.js',
'rxjs': 'npm:rxjs@6.4.0',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.26.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.6',
'jszip': 'npm:jszip@3.6.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.10.3/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.18',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.24',
'devextreme-angular': 'npm:devextreme-angular@20.2.6',
'preact': 'npm:preact@10.5.13/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.13/hooks/dist/hooks.js'
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts'
},
'devextreme': {
defaultExtension: 'js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
packageConfigPaths: [
"npm:@angular/*/package.json",
"npm:@angular/common/*/package.json",
"npm:rxjs/package.json",
"npm:rxjs/operators/package.json",
"npm:devextreme-angular/*/package.json",
"npm:devextreme-angular/ui/*/package.json",
"npm:devextreme-angular/package.json",
"npm:devexpress-diagram/package.json",
"npm:devexpress-gantt/package.json",
]
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.10.2/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.3/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import('app').catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

import React from 'react';
import RowTemplate from './RowTemplate.js';
const years = ['2010', '2011', '2012'];
export default function App() {
return (
<React.Fragment>
<div className="long-title"><h3>Monthly Prices of Oil, Gold and Silver</h3></div>
<div id="chart-demo">
<table className="demo-table">
<tbody>
<tr>
<th />
<th>Oil (USD/barrel)</th>
<th>Gold (USD/troy ounce)</th>
<th>Silver (USD/troy ounce)</th>
</tr>
{
years.map((year, index) => <RowTemplate key={index} year={year} />)
}
</tbody>
</table>
</div>
</React.Fragment>
);
}
import React from 'react';
import Sparkline, {
Tooltip,
} from 'devextreme-react/sparkline';
import {
oilCosts,
silverCosts,
goldCosts,
} from './data.js';
export default function RowTemplate(props) {
return (
<tr>
<th>{props.year}</th>
<td>
<Sparkline
dataSource={oilCosts}
showMinMax={true}
className="sparkline"
argumentField="month"
valueField={props.year}
type="line"
>
<Tooltip format="currency" />
</Sparkline>
</td>
<td>
<Sparkline
dataSource={goldCosts}
lineWidth={3}
showMinMax={true}
showFirstLast={false}
className="sparkline"
argumentField="month"
valueField={props.year}
type="spline"
lineColor="#9ab57e"
minColor="#6babac"
maxColor="#ebdd8f"
>
<Tooltip format="currency" />
</Sparkline>
</td>
<td>
<Sparkline
dataSource={silverCosts}
pointSize={6}
className="sparkline"
argumentField="month"
valueField={props.year}
type="stepline"
lineColor="#e8c267"
firstLastColor="#e55253"
pointSymbol="square"
pointColor="#ebdd8f"
>
<Tooltip format="currency" />
</Sparkline>
</td>
</tr>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.3/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#chart-demo {
height: 440px;
}
.demo-table {
width: 100%;
border: 1px solid #c2c2c2;
border-collapse: collapse;
}
.demo-table th,
.demo-table td {
font-weight: 400;
width: 200px;
padding: 25px 10px 5px 10px;
border: 1px solid #c2c2c2;
}
.demo-table th {
padding: 25px 15px 20px 15px;
border: 1px solid #c2c2c2;
}
.demo-table tr:nth-child(2) td {
border-top: 1px solid #c2c2c2;
}
.demo-table td:first-of-type {
border-left: 1px solid #c2c2c2;
}
.demo-table .sparkline {
width: 200px;
height: 30px;
}
.long-title h3 {
font-weight: 200;
font-size: 28px;
text-align: center;
margin-bottom: 20px;
margin-top: 0;
}
export const oilCosts = [{
month: 1,
2010: 77,
2011: 93,
2012: 107,
}, {
month: 2,
2010: 72,
2011: 101,
2012: 112,
}, {
month: 3,
2010: 79,
2011: 115,
2012: 123,
}, {
month: 4,
2010: 82,
2011: 116,
2012: 123,
}, {
month: 5,
2010: 86,
2011: 124,
2012: 116,
}, {
month: 6,
2010: 73,
2011: 115,
2012: 102,
}, {
month: 7,
2010: 73,
2011: 110,
2012: 94,
}, {
month: 8,
2010: 77,
2011: 117,
2012: 105,
}, {
month: 9,
2010: 76,
2011: 113,
2012: 113,
}, {
month: 10,
2010: 81,
2011: 103,
2012: 111,
}, {
month: 11,
2010: 83,
2011: 110,
2012: 107,
}, {
month: 12,
2010: 89,
2011: 109,
2012: 110,
}];
export const goldCosts = [{
month: 1,
2010: 1115,
2011: 1358,
2012: 1661,
}, {
month: 2,
2010: 1099,
2011: 1375,
2012: 1742,
}, {
month: 3,
2010: 1114,
2011: 1423,
2012: 1677,
}, {
month: 4,
2010: 1150,
2011: 1486,
2012: 1650,
}, {
month: 5,
2010: 1205,
2011: 1511,
2012: 1589,
}, {
month: 6,
2010: 1235,
2011: 1529,
2012: 1602,
}, {
month: 7,
2010: 1193,
2011: 1573,
2012: 1593,
}, {
month: 8,
2010: 1220,
2011: 1765,
2012: 1634,
}, {
month: 9,
2010: 1272,
2011: 1771,
2012: 1750,
}, {
month: 10,
2010: 1345,
2011: 1672,
2012: 1745,
}, {
month: 11,
2010: 1370,
2011: 1741,
2012: 1720,
}, {
month: 12,
2010: 1392,
2011: 1643,
2012: 1684,
}];
export const silverCosts = [{
month: 1,
2010: 17,
2011: 30,
2012: 27,
}, {
month: 2,
2010: 28,
2011: 28,
2012: 33,
}, {
month: 3,
2010: 34,
2011: 34,
2012: 35,
}, {
month: 4,
2010: 37,
2011: 37,
2012: 32,
}, {
month: 5,
2010: 47,
2011: 47,
2012: 30,
}, {
month: 6,
2010: 37,
2011: 37,
2012: 28,
}, {
month: 7,
2010: 34,
2011: 34,
2012: 27,
}, {
month: 8,
2010: 40,
2011: 40,
2012: 27,
}, {
month: 9,
2010: 41,
2011: 41,
2012: 31,
}, {
month: 10,
2010: 30,
2011: 30,
2012: 34,
}, {
month: 11,
2010: 34,
2011: 34,
2012: 31,
}, {
month: 12,
2010: 32,
2011: 32,
2012: 33,
}];
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.1.3/cjs',
'devextreme-react': 'npm:devextreme-react@22.1.3',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.16/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.57/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.30/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.7',
'inferno': 'npm:inferno@7.4.4/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.7/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);